import java.util.Scanner;

class Alumno {
    private String nombre;
    private int aciertos;

    public Alumno(String n) {
	nombre = n;
	aciertos = 0;
    }
    public String toString() {
	return nombre;
    }
    public void asignarAciertos(int puntos) {
	aciertos = puntos;
    }
    public int obtenerAciertos() {
	return aciertos;
    }
}

public class BinSort {

public static void ordenamientoPorRecipientes (Lista datos, int rango) {
  if (rango <= 0) return;
  Lista[] recipiente = new Lista[rango + 1];

  for (int i = 0; i < rango; i++)
    recipiente[i] = new Lista();

  //Distribuye la informacin en los recipientes
  java.util.Iterator it = datos.iterador();
  while (it.hasNext()) {
    Alumno alum = (Alumno) it.next();
    recipiente[alum.obtenerAciertos()].agregar(alum);
  }

  //Recoge la informacin de los recipientes
  datos.vaciar();
  for (int i = 0; i < rango; i++){
    it = recipiente[i].iterador();
    while (it.hasNext()) 
      datos.agregar(it.next());
  }
}

  public static void main (String [] pps) {
      BinSort bs = new BinSort();
      Lista listaAlumnos = new Lista();
      Alumno alum = null;

      for(int i = 0; i < 500; i++) {
	  alum = new Alumno("alum"+i);
	  int ac= (int) (Math.random()*120);
	  alum.asignarAciertos(ac);
	  listaAlumnos.agregar(alum);
      }

      for (java.util.Iterator it = listaAlumnos.iterador(); it.hasNext(); ) {
	  alum = (Alumno)it.next();
	  System.out.print(alum + " "+ alum.obtenerAciertos()+" ");
      }

      bs.ordenamientoPorRecipientes(listaAlumnos, 120);

      Scanner in = new Scanner(System.in);
      in.nextLine();

      for (java.util.Iterator it = listaAlumnos.iterador(); it.hasNext(); ) {
	  alum = (Alumno)it.next();
	  System.out.println(alum + " "+ alum.obtenerAciertos());
      }
  } 
}
