import java.util.NoSuchElementException;
/**
 * Implementacin de la interfaz Listable utilizando nodos ligados y un nodo 
 * centinela al inicio de la lista.
 * @author Amparo Lpez Gaona 
 * @version Septiembre 2006
 */

public class Lista implements Listable{
  private Nodo inicio;

  /**  Construye la lista */
  public Lista() {
    inicio = null;
  }
  /** Constructor de copia
   * @param lis -- lista que se copiara
   */
  public Lista (Lista lista) {
    inicio = new Nodo(lista.inicio);
    Nodo lis = lista.inicio;
    Nodo pos = inicio;

    while (lis != null) {
      pos = new Nodo(lis);
      lis = lis.sgte;
    }
  }

  /** Prueba que la lista est vaca. 
   * @return true si est vaca y false en otro caso.
   */
  public boolean estaVacia() {
    return inicio == null;
  }
  /** Crea una lista vaca.  */
  public void vaciar() {
    inicio = null;
  }
  /** Devuelve el primer elemento de la lista **/
  public Object primerElemento() {
      if (!estaVacia())
	  return inicio.elemento;
      throw new NoSuchElementException("La lista no tiene elementos");
  }

  /**
   * Devuelve un valor booleando indicando si el elemento est en la lista
   * @param dato el objeto a buscar.
   * @return boolean - devuelve true si el elemento est en la lista y false
   *                 en caso contrario
   */
  public boolean contiene(Object dato) {
      return buscar(dato) != null;
  }

  /**
   * Devuelve el nodo que contiene el dato buscado.
   * @param dato el objeto a buscar.
   * @return nodo - el nodo que contiene el dato buscado o null si el dato 
   *         no se encuentra en la lista.
   */
    private Nodo buscar (Object dato) {  //Feb'10
    Nodo pos = inicio;

    while(pos != null && ! pos.elemento.equals(dato)) 
      pos = pos.sgte;
    return pos;
    }
  /**
   * Sustituye el valor actual de un nodo por otro nuevo.
   * @param orig -- valor original
   * @param nuevo -- nuevo valor
//   * @throws NoSuchElementException - si el elemento no se encuentra en la lista
   */
    public void sustituir(Object orig, Object nuevo) {
    Nodo n = buscar(orig);
    if ( n!= null)
	n.elemento = nuevo;
    else
     throw new java.util.NoSuchElementException("El elemento "+orig + " no est en la lista");
    }
  /**
   * Inserta el primer elemento de la lista.
   * @param dato el dato a agregar.
   */
  public void agregar(Object dato) {
    inicio = new Nodo(dato,inicio);
  }
  /**
   * Elimina la primera ocurrencia de un dato.
   * @param dato el dato a eliminar.
   */
    public void eliminar(Object dato) { 
    Nodo pos = inicio, anterior = null;

    while(pos != null && !pos.elemento.equals(dato)) {
      anterior = pos;
      pos = pos.sgte;
    }
    if (pos != null) {
    if(pos == inicio)          // Es el inicio de la lista
	inicio = inicio.sgte;
    else 
      anterior.sgte = pos.sgte; 
    } //else	throw new java.util.NoSuchElementException();
  }

  public java.util.Iterator iterador() { 
    return new MiIterador(); 
  }
	
  /**
   * Clase que implementa el iterador
   */
  private class MiIterador implements java.util.Iterator {
    private Nodo posicion = inicio;

    public boolean hasNext() { return posicion != null;}

    public Object next() throws java.util.NoSuchElementException {
      if (hasNext()) {
	Object o = posicion.elemento;
	posicion = posicion.sgte;
	return o;
      }
      throw new java.util.NoSuchElementException();
      //return null;
    }

    public void remove() {
      throw new IllegalStateException();
    }
  }
}

