import java.io.*;
import java.util.Iterator;

/**
 * Clase que permite tener una lista donde cada elemento a su vez es una
 * lista.
 * @author Amparo Lpez Gaona
 * @version 1. Abril 2009
 */
class ListaDeIds {
  Lista ids;

  /** Constructor por omisin */
  ListaDeIds()    {
      ids = new Lista(new ComparadorNyL());
  }

  /** 
   * Mtodo que permite insertar en una lista, cuyo nombre es dado,  el
   * elemento especificado
   * @param nombreLista - nombre de la lista en que se har la insercin
   * @param elementoLista - elemento que se insertar
   */
  public void insertar(String identificador, Integer linea) {
	Iterator it = ids.elementos();
	while (it.hasNext()) {
	    IdyLista id = (IdyLista) it.next();
	    if (id.obtenerNombre().equals(identificador)) {
		Lista lis = id.obtenerLista();
		lis.agregar(linea);
		return;  //Agreg nmero de lnea.
	    }
	}
	//No est este identificador
      Lista lis = new Lista();
      lis.agregar(linea);
      ids.agregar(new IdyLista(identificador, lis));
    }

/**
 * Mtodo para imprimir la lista
   * @param nombreLista - nombre de la lista que se imprimir
   * @param elementoLista - elemento que ...
 */
    void imprimir() {
	for(Iterator it = ids.elementos(); it.hasNext(); ) {
	    IdyLista nl = (IdyLista) it.next();
	    System.out.print(nl.obtenerNombre() + ": ");
	    Lista ll = nl.obtenerLista();
	    for (Iterator il = ll.elementos(); il.hasNext(); ) 
		System.out.print(il.next()+ ", ");
	    System.out.println();
	}
    }

    private class ComparadorNyL implements java.util.Comparator {
	public int compare(Object o1, Object o2) {
	    String oo1 = ((IdyLista) o1).obtenerNombre();
	    String oo2 = (String) o2;
	    return oo1.compareToIgnoreCase(oo2);
	}
    }

}

class Main  {
    private static String [] reservadas = {
	"abstract", "else", "interface", "static", "boolean", "extends", "long",
	"super", "break", "false", "main", "switch","byte", "final", "native",
	"synchronized", "case", "finally", "new", "this", "catch", "float",
	"null", "throw", "char", "for", "package", "throws", "class", "if",
	"private", "true", "continue", "implements", "protected", "try",
	"default", "import", "public", "void", "do", "instanceof", "return",
	"volatile", "double", "int", "short", "while"};

    private static boolean palRes(String palabra) {
	for (int i = 0; i< reservadas.length; i++)
	    if (palabra.compareTo(reservadas[i]) == 0) {
		return true;
	    }
	return false;
    }

  public static void main (String [] args) {
      ListaDeIds lisId = new ListaDeIds();
      int tipoTok;

      // Paso 1. Leer los datos y formar las listas.
    try {
      BufferedReader in = new BufferedReader (new FileReader(args[0]));
      StreamTokenizer tok = new StreamTokenizer(in);
       	tok.ordinaryChar('.');
	//	tok.lowerCaseMode(true);
       	tipoTok = tok.nextToken();
       	while (tipoTok != StreamTokenizer.TT_EOF) {
	    if (tipoTok == StreamTokenizer.TT_WORD) 
		if (! palRes(tok.sval))
		    lisId.insertar(tok.sval, new Integer(tok.lineno()));
	    tipoTok = tok.nextToken();
       	}

      // Paso 2. Imprime las listas

      lisId.imprimir();
    } catch(IOException e) {
      System.out.println("Se genero IOException "+e);
    }
  }
}
